package com.example.as_trak.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.as_trak.R;
import com.example.as_trak.databinding.ItemLoadInfoBinding;
import com.example.as_trak.entity.LoadOperation;

import java.util.List;

public class LoadInfoAdapter extends RecyclerView.Adapter<LoadInfoAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;
    private List<LoadOperation> list;
    private LoadInfoCall call;

    public LoadInfoAdapter(Context context, LoadInfoCall call) {
        this.context = context;
        inflater = LayoutInflater.from(context);
        this.call = call;
    }

    public void setList(List<LoadOperation> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemLoadInfoBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_load_info, parent, false, null);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        ItemLoadInfoBinding binding = holder.binding;
        LoadOperation data = list.get(position);
        data.setOrderNum(position+1);
        binding.setData(data);
        binding.itemLoadD.setOnClickListener(v -> call.deleteCargoInfo(position));
        binding.itemLoadU.setOnLongClickListener(v -> {
            call.updateCargoInfo(position);
            return true;
        });
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }


    static class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemLoadInfoBinding binding;

        public MyViewHolder(ItemLoadInfoBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }

    public interface LoadInfoCall {
        void updateCargoInfo(int index);

        void deleteCargoInfo(int index);

    }
}
